> For the complete documentation index, see [llms.txt](https://docs.cybus.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.cybus.io/2-0-6/documentation/services/service-commissioning-files/resources/cybus-role.md).

# Cybus::Role

The **Cybus::Role** resource allows you to define a reusable set of permissions that can later be assigned to one or more [Cybus::User](/2-0-6/documentation/services/service-commissioning-files/resources/cybus-user.md) resources. This is the recommended approach for managing permissions in Connectware, as it ensures consistency and simplifies maintenance.

See also [User Management](/2-0-6/documentation/user-management.md).

## Role Properties

| Property                    | Type       | Required     |
| --------------------------- | ---------- | ------------ |
| [permissions](#permissions) | `object[]` | **Required** |

### permissions

Defines the list of permissions granted to any user assigned to this role.

* **Required**
* Type: `object[]`
* Each item must be of type `object` with the following properties:

| Property                | Type   | Required     |
| ----------------------- | ------ | ------------ |
| [context](#context)     | string | **Required** |
| [operation](#operation) | string | **Required** |
| [resource](#resource)   | string | **Required** |

#### context

The context in which the role permissions for the resource should be interpreted.

* **Required**
* Type: `enum`
* The value of this property **must** be one of the following:
  * `mqtt` when describing permissions for MQTT topics
  * `http` when describing permissions for REST API paths

#### operation

The allowed access operation to the resource.

* **Required**
* Type: `enum`
* The value of this property **must** be one of the following:
  * `read`
  * `write`
  * `readWrite`

#### resource

The resource path to which the permission applies. This can be either:

* An MQTT topic (e.g., `edge.cybus/#`)
* A RESTful API path
* **Required**
* Type: `string`

## Example

{% code lineNumbers="true" %}

```yaml
myRole:
  type: Cybus::Role
  properties:
    permissions:
      - resource: edge.cybus/#
        operation: readWrite
        context: mqtt
```

{% endcode %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.cybus.io/2-0-6/documentation/services/service-commissioning-files/resources/cybus-role.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
